#include <bits/stdc++.h>
using namespace std;

void fail(const string &msg) { cout << msg << endl; exit(1); }
void accept() { cout << "OK" << endl; exit(0); }

int G[26][26][26][26];

int main(int argc, char **argv) {
    assert( argc == 3 );
    ifstream fin(argv[1]), ftheir(argv[2]);
    assert( fin );
    assert( ftheir );

    int T; fin >> T;
    while (T--) {
        int N; fin >> N;
        int correctS = 1;
        while ((correctS * correctS) % N) ++correctS;

        int S;
        if (!(ftheir >> S)) fail("Wrong answer: expected an integer.");
        if (S != correctS) fail("Wrong answer: incorrect square size.");

        vector<string> plan(S);
        for (int s=0; s<S; ++s) {
            if (!(ftheir >> plan[s])) fail("Wrong answer: expected a string of length s.");
            if (int(plan[s].size()) != S) fail("Wrong answer: expected a string of length s.");
            for (char c : plan[s]) if (c < 'a' || c >= 'a'+N) fail("Wrong answer: expected one of the first N lowercase letters.");
        }

        vector<int> counts(N,0);
        for (int s=0; s<S; ++s) for (int t=0; t<S; ++t) ++counts[ plan[s][t]-'a' ];
        for (int n=0; n<N; ++n) if (counts[n] != S*S/N) fail("Wrong answer: each letter must appear the same number of times.");

        memset(G,0,sizeof(G));
        for (int a=0; a<S; ++a) for (int b=0; b<S; ++b) for (int c=0; c<S; ++c) for (int d=0; d<S; ++d) if (abs(a-c)+abs(b-d)<=1) if (plan[a][b]==plan[c][d]) G[a][b][c][d] = G[c][d][a][b] = 1;
        for (int e=0; e<S; ++e) for (int f=0; f<S; ++f) for (int a=0; a<S; ++a) for (int b=0; b<S; ++b) for (int c=0; c<S; ++c) for (int d=0; d<S; ++d) if (G[a][b][e][f] && G[e][f][c][d]) G[a][b][c][d] = 1;
        for (int a=0; a<S; ++a) for (int b=0; b<S; ++b) {
            int comp_size = 0;
            for (int c=0; c<S; ++c) for (int d=0; d<S; ++d) if (G[a][b][c][d]) ++comp_size;
            if (comp_size != counts[0]) fail("Wrong answer: each letter must form a 4-connected region.");
        }
    }
    accept();
}
